require "baja/version"
require 'rails'
require 'yaml'
require 'bundler'
require 'factory_girl_rails'


module Baja 



  class Blast
    @@definition_file_paths  =  %w(factories test/factories spec/factories).map { |path| File.expand_path(path) }
    @@baja = JSON.parse(File.read('baja.json'),:symbolize_names => true)
    def self.now!      
      unless Baja::Blast.baja[:factories].nil?
        @@baja[:factories].each do |dew|

          drink = IO.popen("bundle show #{dew[:name]}").readline.strip
          unless dew[:dependencies].nil?
            dew[:dependencies].each do |d|
              load("#{drink}/#{d[:path]}"  )
            end
          end
          @@definition_file_paths << Pathname.new("#{drink}/spec/factories").to_s
          @@definition_file_paths.uniq!
          puts @@definition_file_paths
        end
      end
      
      
    end
    def self.baja 
      @@baja
    end
    def self.definition_file_paths
      @@definition_file_paths
    end    
  end

  class Railtie < Rails::Railtie 
    rake_tasks do 
      load "tasks/baja.rake"
    end
  end


end

 module FactoryGirl
    def self.find_definitions

      Baja::Blast.definition_file_paths.each do |path|
        puts "abspath: #{path}"
        FactoryLoad.load_path("#{path}.rb") if File.exist?("#{path}.rb")

        if File.directory? path
          Dir[File.join(path, '**', '*.rb')].sort.each do |file|
            FactoryLoad.load_path(file)
          end
        end
      end
    end
  end


module FactoryLoad
  @@path
  def self.load_path(path)
    @@path = path
    puts path
    load(path) 
  end
  def self.path
    @@path
  end
 
end 




  FactoryGirl::Syntax::Default::DSL
  class FactoryGirl::Syntax::Default::DSL
    @namespace
    def namespace(name)
      @namespace = name.to_s
      yield
    end
    def factory(name, options = {}, &block)  
      options[:class] = name.to_s.gsub(/_list/,'') unless options.has_key?(:class) 
      name = :"#{@namespace}___#{name.to_s}" unless @namespace.nil?

      unless @namespace.nil?
        name = :"#{@namespace}__#{name.to_s}" 
      else
        puts "#{Baja::Blast.baja.as_json}"
        unless Baja::Blast.baja[:factories].nil?
          Baja::Blast.baja[:factories].each do |dew|            
            if FactoryLoad.path.include?(dew[:name])            
              name = :"#{dew[:name]}__#{name.to_s}" 
            end            
          end
        end        
      end
      puts "name: #{name}"
      factory = FactoryGirl::Factory.new(name, options)
      proxy = FactoryGirl::DefinitionProxy.new(factory.definition)
      proxy.instance_eval(&block) if block_given?

      FactoryGirl.register_factory(factory)

      proxy.child_factories.each do |(child_name, child_options, child_block)|
        parent_factory = child_options.delete(:parent) || name
        factory(child_name, child_options.merge(parent: parent_factory), &child_block)
      end
    end
  end




